Attribute VB_Name = "Module1"

Public Const ndim = 200
Const pi = 3.141592653589
Dim dist9(ndim), v91(ndim), v92(ndim), mass9(ndim), ax1(ndim), ax2(ndim)       ' test 9
Public disktype, dzdisk, shape, rvisgal, dbulge, rvgal, ddisk, rtotgal                 'DISK
Public cnr0, nz0, dalpha0
Public ddisk0, rvgal0, rbulge0, rtgal0, spvel0, shape0, disktype0, denscor0, calib0     'DISK
Dim Year As Long
Dim mystr As String
Public nz, cnr, rbulge, spval, calib, savedata, dndim As Integer
Public denscor, masgal0, dmasgal
Public temp As String
Public Const Lightyear = 9460000000000#

Sub Main()

'                       MASS_GAL.BAS
'       Revision 1.0    Original                          28 Nov 1995
'       Revision 1.1    Corection massdisk & massdisk1    29 Dec 1995
'       Revision 2      Added Sun Corr factor             17 Feb 2002
'

Const ESC = 27, ENTER = 13
Const E41 = 1E+41
Title$ = "Sun Radius Calculation"
Display = 1
Form1.StartCommand.Caption = ""

CLS:
      Tkomma Form1.Tshape.Text, temp: Form1.Tshape.Text = temp         ' Change . into ,
      Tkomma Form1.Tspvel.Text, temp: Form1.Tspvel.Text = temp        ' Change . into ,
      Tkomma Form1.Tdenscor.Text, temp: Form1.Tdenscor.Text = temp       ' Change . into ,
      If Form1.Tcnr.Text < 1 Then Form1.Tcnr.Text = 1
      If Form1.Tnz.Text < 1 Then Form1.Tnz.Text = 1
      If Form1.Tdalpha.Text < 3 Then Form1.Tdalpha.Text = 3
      If Form1.Tdalpha.Text > 45 Then Form1.Tdalpha.Text = 45
      If Form1.Trbulge.Text < 2000 Then Form1.Trbulge.Text = 2000
      If Form1.Trvgal.Text > ndim * 1000# Then Form1.Trvgal.Text = ndim * 1000#
      If Form1.Trtotgal.Text > ndim * 1000# Then Form1.Trtotgal.Text = ndim * 1000#
      If Form1.Thdisk.Text > 10000 Then Form1.Thdisk.Text = 10000
      If Form1.Thdisk.Text < 500 Then Form1.Thdisk.Text = 500
      ' If Form1.Tshape.Text > 1 Then Form1.Tshape.Text = 1
      ' If Form1.Tshape.Text < 0 Then Form1.Tshape.Text = 0
      If Form1.Tspvel.Text < 100 Then Form1.Tspvel.Text = 100
      Form1.Tdisktype.Text = Int(Form1.Tdisktype.Text)
      If Form1.Tdisktype.Text < 1 Then Form1.Tdisktype.Text = 1
      If Form1.Tdisktype.Text > 4 Then Form1.Tdisktype.Text = 4
      If Form1.Tdenscor.Text < 0 Then Form1.Tdenscor.Text = 0
      If Form1.Tdenscor.Text > 1 Then Form1.Tdenscor.Text = 1
      Form1.Tcalib.Text = Int(Form1.Tcalib.Text)
    
    cnr = Form1.Tcnr.Text
    nz = Form1.Tnz.Text
    dalpha = Form1.Tdalpha.Text
    ddisk = Form1.Thdisk.Text          'height disk
    rvgal = Form1.Trvgal.Text          'radius visible galaxy
    rbulge = Form1.Trbulge.Text        'radius bulge
    rtgal = Form1.Trtotgal.Text        'radius total galaxy
    spvel = Form1.Tspvel.Text          'sp velocity
    shape = Form1.Tshape.Text          'shape
    disktype = Form1.Tdisktype.Text
    denscor = Form1.Tdenscor.Text
    calib = Form1.Tcalib.Text
    dndim = Int(rtgal / 1000)          ' delta ndim   maximum = ndim
    test = Form1.TTest.Text
    
    If cnr <> cnr0 Then savedata = 0
    If nz <> nz0 Then savedata = 0
    If dalpha <> dalpha0 Then savedata = 0
    If ddisk <> ddisk0 Then savedata = 0          'height disk
    If rvgal <> rvgal0 Then savedata = 0       'radius visible galaxy
    If rbulge <> rbulge0 Then savedata = 0:         'radius bulge
    If rtgal <> rtgal0 Then savedata = 0        'radius total galaxy
    If spvel <> spvel0 Then savedata = 0          'sp velocity
    If shape <> shape0 Then savedata = 0          'shape
    If disktype <> disktype0 Then savedata = 0
    If denscor <> denscor0 Then savedata = 0
    If calib <> calib0 Then savedata = 0
   
    cnr0 = cnr: nz0 = nz
    dalpha0 = dalpha
    ddisk0 = ddisk                      'height disk
    rvgal0 = rvgal                      'radius visible galaxy
    rbulge0 = rbulge                    'radius bulge
    rtgal0 = rtgal                      'radius total galaxy
    spvel0 = spvel                      'sp velocity
    shape0 = shape                      'shape
    disktype0 = disktype
    denscor0 = denscor
    calib0 = calib

''CLS
 
  dbulge = rbulge * Lightyear        ' radius bulge
  dsun = 25000 * Lightyear           ' distance sun
  rvisgal = rvgal * Lightyear        ' radius outer visible galaxy
  rtotgal = rtgal * Lightyear        ' radius outer galaxy
  dzdisk = ddisk * Lightyear         ' height disk
  dzdisk = dzdisk / 2                ' half height disk
  dsuncal = dsun

  If savedata = 1 Then Display = 2                   ' Skip Display = 1

s0:
s1:

Select Case Display

Case Is = 1
    
    Form1.Tmbulge.Text = ""
    Form1.Tmdisk.Text = ""
    Form1.Ttmgalaxy.Text = ""
    Form1.Tdbulge = ""
    Form1.Tddisk = ""
  
  G = 6.67E-20
  m0 = 2E+30 * 110000000000#           ' Galaxy  mass in kg
  m1 = 2E+30                           ' Sun
  Year = 365.25 * 24 * 60 * 60
  ''scren% = 12: Screen scren%
  ychrmax = 29
  ''Debug.Print "distance"; Tab(21); "v km/sec"; Tab(40); "rev time in million years"
  ddsun = 1000 * Lightyear           ' step size distance
  ' If savedata = 1 Then ddsun = ddsun / 5
  If masgal0 = 0 Then calib = 1         ' force calibration - initial

' Calculation mass in the center
If calib > 0 Then
  For dsun1 = ddsun To rtotgal Step ddsun
     DoEvents
     dist = dsun1
     mm01 = m0 + m1
     r0 = dist * m1 / mm01
     r1 = dist - r0
     vr0 = Sqr(r0 * m1 * G) / dist
     vr1 = Sqr(r1 * m0 * G) / dist          ' meter/sec
     i = dsun1 / ddsun - 1: dist9(i) = dsun1: v91(i) = vr1
     ''If dist = dsun Then Color 7 Else Color 15
     dll = dist / Lightyear
     If dll < 52000 And dll Mod 5000 = 0 Then
        Debug.Print dll, vr1, 2 * pi * r1 / (vr1 * Year * 1000000)
     End If
   Next dsun1
End If
Form1.StartCommand.Caption = "1"
calib1 = calib               ' calibration
If calib1 = 1 Then
  masgal0 = m0                 ' total mass inner galaxy
  dmasgal = 0
End If
nrend = cnr * dndim
nr = nrend * dbulge / rvisgal

Debug.Print "nrend"; nrend, "nr"; nr; dbulge; "rvisgal"; rvisgal
Debug.Print "distance"; Tab(13); "mass < dist"; Tab(29); "mass correct"; Tab(48); "v km/sec";
Debug.Print Tab(60); "ax bulge"; Tab(72); "ax disk"

cal1:
masgal = masgal0 - dmasgal                 ' total mass inner galaxy
volcent = 4 / 3 * pi * dbulge * dbulge * dbulge
densgal = masgal / volcent
dd = dbulge / nr: dphi = dalpha                ' radius bulge / nr
' nrend = rvisgal / dbulge * nr                   ' based on inner maximum
accuz = nz

' disk calculation

For dsun1 = 1 * ddsun To rtotgal Step ddsun          ' ddsun = 1000
DoEvents
If calib1 = 0 Then
    mystr = Format(2 + dsun1 / rtotgal, "##.#"):
    Form1.StartCommand.Caption = mystr
End If
If calib1 >= 1 Then dsun1 = dsuncal
  voldisk = 0: massdisk = 0: massdisk1 = 0: axdisk = 0

  For r = 1 To nrend
    r1 = (r - 0.5) * dd
    dzdiskcor = DISK(r1)
    For phi = 0 To 180 - dphi Step dphi
      phi1 = (phi + dphi / 2) * pi / 180
      x = r1 * Cos(phi1): y = r1 * Sin(phi1)
      dx = dsun1 - x:
      If dzdiskcor > 0 Then
        dvol = pi * dd * dphi / 180 * dzdiskcor * r1
        'dm = dvol * densgal * denscor
        dm = dvol * densgal * denscor * Densscor((r - 0.5), nrend, 0.5)
        ddzdiskcor = dzdiskcor / accuz:
        ddvol = dvol / accuz:
        'ddm = ddvol * densgal * denscor
        ddm = ddvol * densgal * denscor * Densscor((r - 0.5), nrend, 0.5)
        For z = 1 To accuz
          z1 = (z - 0.5) * ddzdiskcor
          rd = Sqr(z1 * z1 + dx * dx + y * y)
          da = ddm / (rd * rd)
          dax = da * dx / rd        'dbulge
          axdisk = axdisk + 4 * dax
        Next z
        voldisk = voldisk + 4 * dvol
        massdisk = massdisk + 4 * dm
      Else
        End
      End If
    Next phi
    If r1 < dsun1 Then massdisk1 = massdisk
    If r Mod 50 = 0 And calib1 = 1 Then Debug.Print r; Tab(7); Int(nr); "r1"; Int(r1 / Lightyear); Tab(24); dsun1 / Lightyear; "ax"; Int(axdisk)
  Next r

'  bulge  part of galaxy calculation

  If dsun1 < dbulge Or calib1 >= 1 Then
    axcent = 0: masscent = 0: masscent1 = 0: volcent1 = 0
    For r = 1 To nr
      r1 = (r - 0.5) * dd
      ' a$ = INKEY$: If a$ = Chr$(ESC) Then GoTo s10
      For phi = 0 To 180 - dphi Step dphi
        phi1 = (phi + dphi / 2) * pi / 180
        x = r1 * Cos(phi1): y = r1 * Sin(phi1)
        dx = dsun1 - x:
        z = Sqr(dbulge * dbulge - r1 * r1)         ' pos height of galaxy
        dvol = pi * dd * dphi / 180 * z * r1
        'dm = dvol * densgal:
        dm = dvol * densgal * Densscor(r, nr, 0.1)
        dz = z / accuz: ddvol = dvol / accuz
        'ddm = ddvol * densgal
        ddm = ddvol * densgal * Densscor(r, nr, 0.1)
        For z = 1 To accuz
          z1 = (z - 0.5) * dz
          rd = Sqr(z1 * z1 + dx * dx + y * y)
          da = ddm / (rd * rd)
          dax = da * dx / rd
          dax1 = 4 * dax
          axcent = axcent + dax1
          masscent = masscent + 4 * ddm
          volcent1 = volcent1 + 4 * ddvol
        Next z
      Next phi
      If r1 < dsun1 Then masscent1 = masscent
    Next r
  Else
    axcent = masscent / (dsun1 * dsun1)                'ax central galaxy
  End If
  masgalcor = (axdisk + axcent) * dsun1 * dsun1
  m0 = masgalcor:
  dist = dsun1
  mm01 = m0 + m1
  r0 = dist * m1 / mm01
  r1 = dist - r0
  vr0 = Sqr(r0 * m1 * G) / dist
  vr1 = Sqr(r1 * m0 * G) / dist          ' meter/sec
     i = dsun1 / ddsun - 1:
     dist9(i) = dsun1: v92(i) = vr1: mass9(i) = massdisk1 + masscent1
     ax1(i) = axcent: ax2(i) = axdisk
  Year = 365.25 * 24 * 60 * 60
  If dsun1 = dsun Then
        COLOR 7
        If calib = 0 Then
            spvel = Int((10 * vr1) + 0.5) / 10
            Form1.Tspvel.Text = spvel
        End If
    Else
        COLOR 15
    End If
  If dsun1 / Lightyear Mod 5000 = 0 Then
  ' IF dsun1 / lightyear MOD 1000 = 0 AND dsun1 / lightyear < 10000 THEN
    Debug.Print dsun1 / Lightyear;
    Debug.Print massdisk1 + masscent1;
    Debug.Print masgalcor;
    Debug.Print "vr1"; vr1;
    Debug.Print Int(axcent);
    Debug.Print Int(axdisk)
  End If

  If calib1 >= 1 Then
    masssave = masgalcor
    dvr1 = vr1 - spvel:
    calib1 = calib1 + 1
    If Abs(dvr1) < 1 Or calib1 > 30 Then
        calib1 = 0:
        Debug.Print "Calibration finished - Start calculation "
        Form1.StartCommand.Caption = "2"
        GoTo cal1
    End If
    ddmasgal = 0.8 * (vr1 - spvel) * masgal0 / spvel
    If ddmasgal > masgal * 0.2 Then ddmasgal = 0.2 * masgal
    dmasgal = dmasgal + ddmasgal: GoTo cal1
  End If
Next dsun1
Debug.Print Tab(7); "mass bulge"; Tab(31); "mass disk"; Tab(49); "total mass galaxy"
Debug.Print masscent; massdisk; masscent + massdisk
mystr = Format(masscent / E41, "##0.######")
Form1.Tmbulge.Text = mystr + " E+41"
mystr = Format(massdisk / E41, "##0.######")
Form1.Tmdisk.Text = mystr + " E+41"
mystr = Format((masscent + massdisk) / E41, "##0.######")
Form1.Ttmgalaxy.Text = mystr + " E+41"
pc3 = 3.26 * 3.26 * 3.26        'par sec
lightyear3 = Lightyear * Lightyear * Lightyear
volly1 = volcent1 / lightyear3: massM0 = masscent / m1
volpc1 = volly1 / pc3
Debug.Print "vol "; volly1;
Debug.Print Tab(24); " ly  mass bulge "; massM0;
Debug.Print "m0  dens "; massM0 / volly1;
Debug.Print " m0/ly"
mystr = Format(massM0 / volly1, "##0.######")
Form1.Tdbulge.Text = mystr + " m0/ly"
Debug.Print "vol "; volpc1;
Debug.Print Tab(24); " pc  mass bulge "; massM0;
Debug.Print "m0  dens "; massM0 / volpc1;
Debug.Print " m0/pc"
' volly = (volcent1 + voldisk) / lightyear3: massM0 = (masscent + massdisk) / m1
volly = (voldisk) / lightyear3: massM0 = (massdisk) / m1
volpc = volly / pc3:
Debug.Print "vol"; volly;
Debug.Print Tab(24); " ly  mass disk "; massM0;
Debug.Print "m0  dens "; massM0 / volly;
Debug.Print " m0/ly"
mystr = Format(massM0 / volly, "##0.######")
Form1.Tddisk.Text = mystr + " m0/ly"
Debug.Print "vol"; volpc;
Debug.Print Tab(24); " pc  mass disk"; massM0;
Debug.Print "m0  dens "; massM0 / volpc;
Debug.Print " m0/pc"
r = 25000 / 70000 * nrend
volx = dvol / lightyear3 / pc3
' Debug.Print densgal * denscor * Densscor((r - .5), nrend, .5) * (lightyear3 * pc3) / m1

Case Is = 2

Form1.StartCommand.Caption = "3"

''Screen scren%:
ychrmax = 29: ychrmax = ychrmax - 3
vmax = 400                    ' max display speed
' rvisgal = 60000
xmax2 = Form2.Picture1.Width
ymax2 = Form2.Picture1.Height

For i = 1 To dndim - 1
   X2 = i * xmax2 / dndim: Y2 = ymax2 - 50
   ' Debug.Print i, dist9(i) / Lightyear / 100, Int(v91(i))
   Y2 = ymax2 * (vmax - (v91(i) + v91(i - 1)) / 2) / vmax
   ' Form2.Picture1.PSet (X2, Y2), QBColor(2)
   ' Line (dist9(i - 1) * 600 / lightyear / rvisgal, 479 - v91(i - 1) * 450 / vmax)-(dist9(i) * 600 / lightyear / rvisgal, 479 - v91(i) * 450 / vmax)
Next i
For i = 1 To dndim - 1
  ' Debug.Print i, dist9(i) / Lightyear / 100, Int(v92(i))
  x = i * xmax / dndim: y = ymax * (vmax - v92(i)) / vmax
  dv92 = v92(i) - v92(i - 1)
  For j = 0 To 3
    x = (i - 1 + j / 4) * xmax / dndim: y = ymax * (vmax - v92(i - 1) - j * dv92 / 4) / vmax
    X2 = (i - 1 + j / 4) * xmax2 / dndim: Y2 = ymax2 * (vmax - v92(i - 1) - j * dv92 / 4) / vmax
    icolor = QBColor(2)
    If test >= 13 Then test = test - 12
    If test > 0 Then icolor = QBColor(test + 1)
    ' If test = 13 Then icolor = QBColor(2)
    Form2.Picture1.PSet (X2, Y2), icolor
    
    ' Print Test # in Picture 1 and 2
    If Form1.TTest.Text > 0 And i = dndim - 5 And j = 0 Then
        Form2.Picture1.Print Form1.TTest.Text
    End If
  Next j

Next i

For i = 0 To rtotgal Step 10000 * Lightyear
  For y = 0 To 100 Step 10
    X2 = xmax2 * (rtotgal - i) / rtotgal
    Form2.Picture1.PSet (X2, ymax2 - y - 50), QBColor(2)
  Next y
Next i

For i = 0 To vmax Step 100
  For x = 0 To 100 Step 10
    Y2 = ymax2 * (vmax - i) / vmax
    Form2.Picture1.PSet (x, Y2), QBColor(2)
  Next x
Next i


  i3& = 6 * vmax / 9: LOCATE 11, 2: Debug.Print i3&;
''i3& = 3 * vmax / 9: LOCATE 21, 2: Debug.Print i3&;
''i3& = 2 * rvisgal / 12: LOCATE 29, 11: Debug.Print i3&;
''i3& = 5 * rvisgal / 12: LOCATE 29, 30: Debug.Print i3&;
''i3& = 10 * rvisgal / 12: LOCATE 29, 60: Debug.Print i3&;
''i3& = rvisgal: LOCATE 29, 73: Debug.Print i3&;
''LOCATE 12, 10: Debug.Print "A"
''LOCATE 20, 30: Debug.Print "B"
  LOCATE 1, 25: Debug.Print "GALAXY ROTATION CURVE"
  LOCATE 2, 25: Debug.Print "Vertical speed in km/sec"
  LOCATE 3, 25: Debug.Print "Horizontal distance in lightyear"
' If savedata = 1 Then COLOR 4: LOCATE 4, 50: Debug.Print "New 'Data"
COLOR 7
  LOCATE 5, 20: Debug.Print "A = mass of galaxy concentrated in one point"
  LOCATE 6, 20: Debug.Print "B = mass of galaxy distributed in bulge and disk"
COLOR 15

Case Is = 3
 
  COLOR 15
  scren% = 12: SCREEN scren%: ychrmax = 29
  Debug.Print "distance"; Tab(12); "v km"; Tab(20); "v km ";
  Debug.Print Tab(28); "mass < dist"; Tab(50); "ax bulge"; Tab(61); "ax disk"; Tab(71); "heigt"
  Debug.Print "in center"; Tab(18); "mass = 3d"; Tab(71); "disk"

  For i = 0 To 8
    dzdiskcor = DISK(dist9(i))
    Debug.Print dist9(i) / Lightyear; Tab(10);
    Debug.Print Int(v91(i)); Tab(18); Int(v92(i));
    Debug.Print Tab(24); mass9(i);
    Debug.Print Tab(50); Int(ax1(i)); Int(ax2(i)); Int(dzdiskcor * 2 / Lightyear)
  Next i
  For i = 9 To dndim - 1 Step 5
    dzdiskcor = DISK(dist9(i))
    If dist9(i) = dsun Then COLOR 7 Else COLOR 15
    Debug.Print dist9(i) / Lightyear; Tab(10);
    Debug.Print Int(v91(i)); Tab(18); Int(v92(i));
    Debug.Print Tab(24); mass9(i);
    Debug.Print Tab(50); Int(ax1(i)); Int(ax2(i)); Int(dzdiskcor * 2 / Lightyear)
  Next i
  Debug.Print " "
  Debug.Print "distance Sun   = "; dsun / Lightyear; "lightyear"
  Debug.Print "height disk    =  "; ddisk; " lightyear"
  Debug.Print "diameter bulge = "; 2 * rbulge; "lightyear"
  Form1.StartCommand.Caption = "Start"
  
  savedata = 1  ' Curve calculated
  
  Exit Sub

Case Else
End
End Select
s99:

s10:
COLOR 14
Display = Display + 1
LOCATE ychrmax, 20: Debug.Print "NEXT DISPLAY ? "; Display

GoTo s0

nr = 75: nz = 20: dalpha = 3

s20:
'Data 75, 20, 3, 700000, 280000
'Data 9.46E+15, 1245.45, 44.63, 3.27011756617339E+39
'Data 1.892E+16, 880.67, 89.18, 1.29090725491316E+40
'Data 2.838E+16, 719.06, 133.65, 2.83965352749871E+40
'Data 3.784E+16, 622.72, 178.08, 4.88115752959631E+40
'Data 4.73E+16, 556.98, 222.49, 7.27087304571802E+40
'Data 5.676E+16, 508.45, 266.86, 9.78247347814539E+40
'Data 6.622E+16, 470.73, 311.16, 1.20129796964217E+41
'Data 7.568E+16, 440.33, 324.08, 1.28797587921703E+41
'Data 8.514E+16, 415.15, 307.95, 1.3254422058432E+41
'Data 9.46E+16, 393.84, 294.92, 1.36675331807844E+41
'Data 1.0406E+17, 375.51, 284.32, 1.41177997120313E+41
'Data 1.1352E+17, 359.53, 275.67, 1.46039024904857E+41
'Data 1.2298E+17, 345.42, 268.63, 1.51244968033897E+41
'Data 1.3244E+17, 332.86, 262.94, 1.56782135149311E+41
'Data 1.419E+17, 321.57, 258.38, 1.62636601593202E+41
'Data 1.5136E+17, 311.36, 254.8, 1.68794219991402E+41
'Data 1.6082E+17, 302.06, 252.07, 1.75240630489078E+41
'Data 1.7028E+17, 293.55, 250.07, 1.81961270634842E+41
'Data 1.7974E+17, 285.72, 248.7, 1.88941384906526E+41
'Data 1.892E+17, 278.49, 247.89, 1.96166033868172E+41
'Data 1.9866E+17, 271.78, 247.56, 2.03620102943703E+41
'Data 2.0812E+17, 265.53, 247.66, 2.11288310788151E+41
'Data 2.1758E+17, 259.69, 248.13, 2.19155217232015E+41
'Data 2.2704E+17, 254.22, 248.92, 2.27205230768161E+41
'Data 2.365E+17, 249.09, 250, 2.35422615543546E+41
'Data 2.4596E+17, 244.25, 251.32, 2.43791497809629E+41
'Data 2.5542E+17, 239.68, 252.85, 2.52295871775268E+41
'Data 2.6488E+17, 235.36, 254.56, 2.60919604794031E+41
'Data 2.7434E+17, 231.27, 256.42, 2.69646441803513E+41
'Data 2.838E+17, 227.38, 258.41, 2.78460008916816E+41
'Data 2.9326E+17, 223.69, 260.51, 2.87343816045253E+41
'Data 3.0272E+17, 220.16, 262.7, 2.96281258405353E+41
'Data 3.1218E+17, 216.8, 264.96, 3.05255616731166E+41
'Data 3.2164E+17, 213.59, 267.28, 3.14250055972962E+41
'Data 3.311E+17, 210.52, 269.63, 3.232476222133E+41
'Data 3.4056E+17, 207.57, 272.01, 3.32231237468256E+41
'Data 3.5002E+17, 204.75, 274.4, 3.41183691960772E+41
'Data 3.5948E+17, 202.03, 276.8, 3.50087633349292E+41
'Data 3.6894E+17, 199.43, 279.18, 3.58925552259958E+41
'Data 3.784E+17, 196.92, 281.55, 3.67679763293274E+41
'Data 3.8786E+17, 194.5, 283.9, 3.76332380440906E+41
'Data 3.9732E+17, 192.17, 286.21, 3.84865285531362E+41
'Data 4.0678E+17, 189.93, 288.48, 3.93260087891506E+41
'Data 4.1624E+17, 187.75, 290.7, 4.01498072812741E+41
'Data 4.257E+17, 185.66, 292.86, 4.09560135568573E+41
'Data 4.3516E+17, 183.63, 294.96, 4.17426696522407E+41
'Data 4.4462E+17, 181.66, 296.99, 4.25077591094845E+41
'Data 4.5408E+17, 179.76, 298.94, 4.32491925706199E+41
'Data 4.6354E+17, 177.92, 300.8, 4.39647886721361E+41
'Data 4.73E+17, 176.13, 302.58, 4.46522482928169E+41
'Data 4.8246E+17, 174.39, 304.25, 4.53091191381628E+41
'Data 4.9192E+17, 172.71, 305.82, 4.59327458066915E+41
'Data 5.0138E+17, 171.07, 307.25, 4.65201971624732E+41
'Data 5.1084E+17, 169.48, 308.55, 4.70681564569088E+41
'Data 5.203E+17, 167.93, 309.67, 4.75727463998519E+41
'Data 5.2976E+17, 166.43, 310.58, 4.80292310233684E+41
'Data 5.3922E+17, 164.96, 311.14, 4.84314565485626E+41
'Data 5.4868E+17, 163.53, 311.07, 4.87706391143873E+41
'Data 5.5814E+17, 162.14, 309.38, 4.90319764919571E+41
'Data 5.676E+17, 160.78, 303.83, 4.91748447872511E+41
'Data 5.7706E+17, 159.46, 294.74, 4.91748447872511E+41
'Data 5.8652E+17, 158.17, 286.2, 4.91748447872511E+41
'Data 5.9598E+17, 156.91, 279.2, 4.91748447872511E+41
'Data 6.0544E+17, 155.68, 273.34, 4.91748447872511E+41
'Data 6.149E+17, 154.47, 268.24, 4.91748447872511E+41
'Data 6.2436E+17, 153.3, 263.7, 4.91748447872511E+41
'Data 6.3382E+17, 152.15, 259.59, 4.91748447872511E+41
'Data 6.4328E+17, 151.03, 255.82, 4.91748447872511E+41
'Data 6.5274E+17, 149.93, 252.33, 4.91748447872511E+41
'Data 6.622E+17, 148.86, 249.07, 4.91748447872511E+41
'Data 0, 0, 0, 0
'Data 3022808, 134902, 6039896, 262353, 9058515, 378740, 12079064, 486742
'Data 15102325, 588338, 18126536, 684590, 21145140, 776200, 19943896, 863688
'Data 15752767, 947454, 12757005, 1027810, 10541840, 1105007, 8857501, 1179245
'Data 7546895, 1250687, 6507071, 1319465, 5668250, 1385690, 4981771, 1449453
'Data 4412855, 1510828, 3936112, 1569878, 3532653, 1626656, 3188194, 1681207
'Data 2891766, 1733571, 2634837, 1783780, 2410690, 1831864, 2213974, 1877850
'Data 2040391, 1921762, 1886450, 1963621, 1749295, 2003449, 1626572, 2041264
'Data 1516325, 2077085, 1416919, 2110929, 1326977, 2142813, 1245334, 2172753
'Data 1171001, 2200764, 1103130, 2226860, 1040993, 2251057, 983962, 2273366
'Data 931493, 2293800, 883111, 2312372, 838403, 2329090, 797006, 2343966
'Data 758601, 2357007, 722907, 2368220, 689674, 2377609, 658681, 2385176
'Data 629731, 2390922, 602649, 2394841, 577277, 2396926, 553474, 2397160
'Data 531113, 2395518, 510081, 2391963, 490274, 2386438, 471598, 2378855
'Data 453970, 2369077, 437312, 2356876, 421554, 2341856, 406633, 2323243
'Data 392490, 2299271, 379072, 2265029, 366331, 2204879, 354222, 2084259
'Data 342703, 1914436, 331737, 1762115, 321289, 1639800, 311327, 1538833
'Data 301822, 1452602, 292745, 1377156, 284071, 1310031, 275778, 1249578
'Data 267842, 1194629, 260244, 1144318
'Data 0, 0

End Sub

Function Densscor(r, nr, n)
  n = n
  a = (n - 1) / (nr / 2)
  b = 2 - n
  Densscor = a * r + b
  ' Densscor = 1
End Function

Function DISK(r)
'                                                           DISK
' dzdisk = height of disk / 2
delr = r - dbulge                ' distance from bulge in ly
h1 = shape * dzdisk              ' bottom heigt
h2 = (1 - shape) * dzdisk        ' top height
distdisk = rtotgal - dbulge      ' distance disk
If r > rvisgal Then
  rcor = 0
Else
  If r < dbulge Then
     rcor = dzdisk
  Else
    Select Case disktype
    Case 1
      rcor = h1 + h2 * (distdisk - delr) / distdisk            ' lineair
    Case 2
      rcor = h1 + h2 * Cos(delr / distdisk * pi / 2)           '  cosinus  0 - 90 degrees
    Case 3
      rcor = h1 + h2 + h2 * Cos(pi / 2 + delr / distdisk * pi / 2)  ' cosinus   90 - 180 degrees
    Case 4
      rcor = h1 + h2 / 2 + h2 / 2 * Cos(delr / distdisk * pi)     ' cosinus  0 - 180 degrees
    End Select
  End If
End If
DISK = rcor
End Function

Sub PrintTAB(posx, num)
If num >= 10000000 Then l = 10: GoTo p1
If num >= 1000000 Then l = 9: GoTo p1
If num >= 100000 Then l = 8: GoTo p1
If num >= 10000 Then l = 7: GoTo p1
If num >= -10000 Then l = 6: GoTo p1
If num >= -100000 Then l = 7: GoTo p1
If num >= -1000000 Then l = 8: GoTo p1
l = 9
p1: Debug.Print Tab(posx - l); num;

End Sub

Sub READ() 'Data()
'                                                                    READ'Data
Dim mdb(10), sdb(10), fdb(10), rdb(10)
Dim zm(7, 7), z(7), zz(7), st(14)           ' GET COEF parameters
Dim zvenus(7), zall(7)                      ' GET COEF results
Dim ax1(70), ax2(70)
'Data1$ = "'Data "
filenm$ = "C:\NOW\FIG\sunrad.db  "
ioerr% = 0
    Open filenm$ For Input As #1
    If ioerr% > 0 Then Exit Sub
    Input #1, nnr, nnz, ndalpa, radsun, eradsun
    If ioerr% > 0 Then Exit Sub
    For i = 0 To 10
      Input #1, rdb(i), sdb(i), mdb(i), fdb(i)
    Next i
    For i = 0 To 7: Input #1, zvenus(i): Next i
    For i = 0 To 7: Input #1, zall(i): Next i
    For i = 0 To 70: Input #1, dist9(i), v91(i), v92(i), mass9(i): Next i
    For i = 0 To 70: Input #1, ax1(i), ax2(i): Next i
    Close

ioerr% = 0
filenm$ = "C:\INTERNET\NETSCAPE\HTMLED\sunrad.bas  "
' filenm$ = "C:\NICK\HTMLED\sunrad.bas  "
Debug.Print filenm$

    Open filenm$ For Output As #1
    If ioerr% > 0 Then Exit Sub
    Write #1, 'Data1$, nnr, nnz, ndalpa, radsun, eradsun
    If ioerr% > 0 Then Exit Sub
    For i = 0 To 70:
      vst1 = Int(v91(i) * 100) / 100
      vst2 = Int(v92(i) * 100) / 100
      Write #1, 'Data1$, dist9(i), vst1, vst2, mass9(i)
    Next i
    For i = 0 To 67 Step 4
      Write #1, 'Data1$, ax1(i), ax2(i), ax1(i + 1), ax2(i + 1), ax1(i + 2), ax2(i + 2), ax1(i + 3), ax2(i + 3)
    Next i
    i = 68: Write #1, 'Data1$, ax1(i), ax2(i), ax1(i + 1), ax2(i + 1)
    i = 70: Write #1, 'Data1$, ax1(i), ax2(i)
    Close

End Sub

Sub COLOR(i4)

End Sub
Sub LOCATE(i1, i2)

End Sub

Sub SCREEN(i1)

End Sub

Sub Tkomma(ins As String, temp As String)
temp = ins
l = Len(temp)
For i = 1 To l
    If Mid$(temp, i, 1) = "." Then Mid$(temp, i, 1) = ","
Next i
' Debug.Print ins, temp
ins = temp
End Sub
